import {
  geoCentroid,
  geoNaturalEarth1
} from 'd3';

// Init Topographic Projection
const projection = geoNaturalEarth1();

// Render the Population circles
export const circles = (selection, props) => {

  // Deconstruct the props argument
  const {
    popData,
    sizeScale,
    sizeValue,
    sizeFormat
  } = props;
  const circleGroup = selection.append('g');   
  
  popData.forEach( d=> {
    d.properties.projected=projection(geoCentroid(d))
  });

  const popCircles = circleGroup.selectAll('circle').data(popData)
   .enter().append('circle')
    .attr('class','country-circle')
  	.attr('cx', d => d.properties.projected[0])
  	.attr('cy', d => d.properties.projected[1])
  	.attr('r', d => sizeScale(sizeValue(d)));
   popCircles
     .append('title')
       .text(d => sizeFormat(sizeValue(d)));
}