// Render the Size Legend
export const sizeLegend = (selection, props) => {
  // Deconstruct the props argument
  const {
    sizeScale,
    xOff,
    yOff,
    itemAmount,
	  itemSpacing,
    itemTextPos,
    tickFormat
  } = props;

  // Add Main Legend Group
  const legendGroup = selection.append('g')
  	.attr('transform',`translate(${xOff}, ${yOff})`);
  
  legendGroup
  	.append('text')
    	.text('Population')
    		.attr('y',-50)
  			.attr('x',-20); 
  
  const ticks = sizeScale.ticks(itemAmount)
  	.filter(d => d>0)
  	.reverse();

  // Create a ticks Group Element
  const groups = legendGroup.selectAll('g')
  	.data(ticks);
  const groupsEnter = groups
  	.enter().append('g')
  		.attr('class','tick');
  groupsEnter
    .merge(groups)
  		.attr('transform', (d, i) =>
      	`translate(0,${i * itemSpacing})`);
  groups.exit().remove();
  
  // Append Child Elements to the Group
  groupsEnter.append('circle')
  	// Use merge to Update Existing DOM Elements
  	.merge(groups.select('circle'))
  		.attr('r', sizeScale);

  // Append Child Elements to the Group
  groupsEnter.append('text')
  		.attr('x',itemTextPos)
  		.attr('dy', 0.32 +'em')
   	// Use merge to Update Existing DOM Elements
  	.merge(groups.select('text'))
  		.text(tickFormat);

}
